clear all
clf
close all

%bed sizing tool

Power = 3;            % kW
SMP = 0.7;            % kW/litre
Volume = Power/SMP;   % litres
V=Volume/1000;        % volume m3
WasteHeatT = 85;      % Waste heat source T (degC)
SensHeatper=0.5;      % factor of heating of shell, i.e percentage of the temperature rise, whole shell experiences
SHP=SensHeatper;

% Disc Spec
DiscOD = 0.0336;      %m
Tdi    = 0.0127;      %tube diameter

Discx  = 0.0095;      %m
DTVol  = Discx*(pi*DiscOD^2)/4;%Disc volume including tube

TVol   = Discx*(pi*Tdi^2)/4;%tube vol
DVol   = DTVol-TVol;  %Volume just disc
TubeThickness=0.00093;%Thickness of tube

%Barium Basis
Numberof.BaDiscs = (V/DTVol);%number of barium discs
N.BaDiscs=round(V/DTVol);
DiscPerTube.Ba=round(Numberof.BaDiscs/7);

BaClSampleOD=0.0336;
SampleOD=0.0345;%reference disks for Non barium hexagons
TubeSize=0.0127; 
ActualSampleVolume=((pi*SampleOD^2/4)-(pi*TubeSize^2/4))*Discx*2;
BaClSampV=((pi*BaClSampleOD^2/4)-(pi*TubeSize^2/4))*Discx*2;
% MassENGpBariumDisc=BaClSampV/2*rhoENG;


% Calc stoich
Barium.MassBasis= 3.095e-3; %masskg/2 hexagons of barium
Barium.ENGMassBasis   = 2.008e-3; %masskg/ ""
MassENGpDisc=2.008e-3/2;
Barium.MassRatio = Barium.MassBasis/Barium.ENGMassBasis; %masssalt/massENG

Barium.MassperDisc=MassENGpDisc*Barium.MassRatio;
BMass=Barium.MassperDisc*2;
ErrorBa=BMass/Barium.MassBasis;

M.BaCl2=(Barium.MassBasis/2)*Numberof.BaDiscs; %kg
nWBaCl2=208.23;       %kg/kmol
mol.BaCl2=M.BaCl2/nWBaCl2;%kmol
nWBaCl2=208.23;       %kg/kmol
Stoich.Ba=8;
molNH3=mol.BaCl2*Stoich.Ba;

% % % Calcium Chloride
Calcium.MassBasis= 2.819e-3; %masskg/2 hexagons of barium
Calcium.ENGMassBasis   = 2.759e-3; %masskg/ ""
Calcium.MassRatio = Calcium.MassBasis/Calcium.ENGMassBasis; %masssalt/massENG
Calcium.MassperDisc=MassENGpDisc*Calcium.MassRatio;
Calcium.PerRef=Calcium.MassBasis/ActualSampleVolume;
Calcium.PerSample=Calcium.PerRef*DVol;%mass of calcium estimated per hexagon

nWCaCl2=110.98;
nCaCl2=Calcium.MassperDisc/nWCaCl2;
Stoich.Ca42=2;
Stoich.Ca84=4;
Stoich.Ca842=6;

mol.CaCl42=molNH3/Stoich.Ca42;%kmols of calcium chloride 4-2basis
M.CaCl42=mol.CaCl42*nWCaCl2; %mass calcium chloride 4-2 reaction basis
mol.CaCl84=molNH3/Stoich.Ca84;
M.CaCl84=mol.CaCl84*nWCaCl2;
mol.CaCl842=molNH3/Stoich.Ca842;
M.CaCl842=mol.CaCl842*nWCaCl2;

Numberof.Ca42Discs = (M.CaCl42/Calcium.PerSample);%number of barium discs
N.Ca42Discs=round(Numberof.Ca42Discs);
DiscPerTube.Ca42=round(Numberof.Ca42Discs/7);

Numberof.Ca84Discs = (M.CaCl84/Calcium.PerSample);%number of barium discs
N.Ca84Discs=round(Numberof.Ca84Discs);
DiscPerTube.Ca84=round(Numberof.Ca84Discs/7);

Numberof.Ca842Discs = (M.CaCl842/Calcium.PerSample);%number of barium discs
N.Ca842Discs=round(Numberof.Ca842Discs);
DiscPerTube.Ca842=round(Numberof.Ca842Discs/7);

% % % Manganese Chloride with BaCl2 LTS
Manganese.MassBasis=4.038e-3; %masskg/2 hexagons of barium
Manganese.ENGMassBasis   = 2.594e-3; %masskg/ ""
Manganese.MassRatio = Manganese.MassBasis/Manganese.ENGMassBasis; %masssalt/massENG
Manganese.MassperDisc=MassENGpDisc*Manganese.MassRatio;
Manganese.PerRef=Manganese.MassBasis/ActualSampleVolume;
Manganese.PerSample=Manganese.PerRef*DVol;%mass of calcium estimated per hexagon

nWMnCl2=125.84;
nMnCl2=Manganese.MassperDisc/nWMnCl2;
Stoich.Mn=4;

mol.MnCl2=molNH3/Stoich.Mn;%kmols of calcium chloride 4-2basis
M.MnCl2=mol.MnCl2*nWMnCl2; %mass calcium chloride 4-2 reaction basis

Numberof.MnDiscs = (M.MnCl2/Manganese.PerSample);%number of barium discs
N.MnDiscs=round(Numberof.MnDiscs);
DiscPerTube.Mn=round(Numberof.MnDiscs/7);
%%%

NumberofDiscs=struct2cell(N);DiscT=struct2cell(DiscPerTube);mass=struct2cell(M);
mole=struct2cell(mol);Stoichiometry=struct2cell(Stoich);

T=table(NumberofDiscs,DiscT,mass,mole,Stoichiometry,'RowNames',{'BaCl2','CaCl2 4-2','CaCl2 8-4','CaCl2 8-4-2','MnCl2'});
T.Properties.VariableNames = {'Number of Discs','Number of Discs Per Tube','Mass of Salt (kg)'...
    'Number of Moles (kmol)','Stoichiometric Ratio'}

% ENTER LTS DESORPTION TEMPERATURE
t2 = WasteHeatT; % [degC] 
% ENTER LTS ADSORPTION DELIVERY TEMPERATURE
t4 = t2; % [degC] 
% ENTER THE ACTIVE FRACTION OR COMPLETION OF THE REACTION (0 - 1)
Xmax = 0.8;

R0 = 8.314; % [J mol^-1 K^-1] Universal gas constant 
NH3.Cps = 53; % [J mol^-1 K^-1] Specific heat of solid (s) ammoniate, taken from Hirata paper 2003 fig.11
NH3.Cpg = 2.76; % [J g^-1 K-1] Specific heat of ammonia gas (g) average from https://tinyurl.com/ya9whv7e
NH3.MW = 17.031; % [g mol^-1]
NH3.Cpg = 2.76*NH3.MW; % [J mol^-1 K^-1] Specific heat of ammonia gas (g) average from https://tinyurl.com/ya9whv7e
ENG.Cp = 720; % [J kg^1 K^-1] specific heat of ENG taken from SJH experiments
SS.Cp = 490; % [J kg^1 K^-1] specific heat of stainless steel 316
AlCp = 900; % [J kg^1 K^-1]
SS.Rho= 7480;% [kg/m3] Density of SS316
tKT=t2+273;
H2O.Cp=4200; %33.80*18.01528/1000; %Cp from NIST based on Tm
H2O.Rho=997;% [kg/m3] Density of Water

SALT = salt(); % Run function containing specific reaction salt data
SALTlist = {SALT.Name}; % User salt selection
% High Temperature Salt choice
    HTSchoice = menu('Select ***High*** Temperature Salt', SALTlist);
    HTS.Name = string(SALT(HTSchoice).Name);
    HTS.MW = SALT(HTSchoice).MW/1000; % [g/mol]
    HTS.Cp = SALT(HTSchoice).Cp; % [J/kg/K]
    HTS.rho = SALT(HTSchoice).rho; % [kg/m3]
    % Properties
        % Reaction 1
        HTS.R1 = SALT(HTSchoice).R1.Properties;
        % For Dummy Reaction
        HTS.R2 = SALT(HTSchoice).R1.Properties;
        HTS.R2.delSads = 0;
        HTS.R2.delSdes = 0;
        % Steps
        HTS.steps = 1; % Single Stage
        
% Low Temperature Salt choice
    LTSchoice = menu('Select ***Low*** Temperature Salt', SALTlist);
    LTS.Name = string(SALT(LTSchoice).Name);
    LTS.MW = SALT(LTSchoice).MW/1000; % [g/mol]
    LTS.Cp = SALT(LTSchoice).Cp; % [J/kg/K]
    LTS.rho = SALT(LTSchoice).rho; % [kg/m3]
    % Properties
    if isempty(SALT(LTSchoice).R2) == 1 % For single step reaction
        % Reaction 1
        LTS.R1 = SALT(LTSchoice).R1.Properties;
        % For Dummy Reaction
        LTS.R2 = SALT(LTSchoice).R1.Properties;
        LTS.R2.delSads = 0;
        LTS.R2.delSdes = 0;
        % Steps
        LTS.steps = 1; % Single Stage
    else % For two step reaction
        % Reaction 1
        LTS.R1 = SALT(LTSchoice).R1.Properties;
        % Reaction 2
        LTS.R2 = SALT(LTSchoice).R2.Properties;
        % Steps
        LTS.steps = 2; % Two Stage
    end
%HTS Coefficients
    HTS.A = HTS.R1.Xmax; % Max
    HTS.B = HTS.R1.Xmin; % Middle
    HTS.C = HTS.R2.Xmin; % Min or Dummy
%LTS Coefficients
    LTS.A = LTS.R1.Xmax; % Max
    LTS.B = LTS.R1.Xmin; % Middle
    LTS.C = LTS.R2.Xmin; % Min or Dummy
%HTS to LTS mol ratio & modified coefficients
    % moleratio [mol HTS / mol LTS]
if HTS.steps == 1 && LTS.steps == 1
    % HTS Modified Coefficients
    HTS.Amod = 0.5*(HTS.B*(1-Xmax)+HTS.A*(1+Xmax));
    HTS.Bmod = 0.5*(HTS.B*(1+Xmax)+HTS.A*(1-Xmax));
    HTS.Cmod = HTS.Bmod; % Dummy 
    % LTS Modified Coefficients
    LTS.Amod = 0.5*(LTS.B*(1-Xmax)+LTS.A*(1+Xmax));
    LTS.Bmod = 0.5*(LTS.B*(1+Xmax)+LTS.A*(1-Xmax));
    LTS.Cmod = LTS.Bmod; % Dummy
    % Mole ratio
    moleratio = (LTS.Amod-LTS.Bmod) / (HTS.Amod-HTS.Bmod); 
elseif HTS.steps == 2 && LTS.steps == 1
    % HTS Modified Coefficients
    HTS.Amod = 0.5*(HTS.C*(1-Xmax)+HTS.A*(1+Xmax));
    HTS.Bmod = HTS.B; % No change
    HTS.Cmod = 0.5*(HTS.C*(1+Xmax)+HTS.A*(1-Xmax));    
    % LTS Modified Coefficients
    LTS.Amod = 0.5*(LTS.B*(1-Xmax)+LTS.A*(1+Xmax));
    LTS.Bmod = 0.5*(LTS.B*(1+Xmax)+LTS.A*(1-Xmax));
    LTS.Cmod = LTS.Bmod; % Dummy
    % Mole ratio
    moleratio = (LTS.Amod-LTS.Bmod) / (HTS.Amod-HTS.Cmod); 
elseif HTS.steps == 1 && LTS.steps == 2
    % HTS Modified Coefficients
    HTS.Amod = 0.5*(HTS.B*(1-Xmax)+HTS.A*(1+Xmax));
    HTS.Bmod = 0.5*(HTS.B*(1+Xmax)+HTS.A*(1-Xmax));
    HTS.Cmod = HTS.Bmod; % Dummy
    % LTS Modified Coefficients
    LTS.Amod = 0.5*(LTS.C*(1-Xmax)+LTS.A*(1+Xmax));
    LTS.Bmod = LTS.B; % No Change
    LTS.Cmod = 0.5*(LTS.C*(1+Xmax)+LTS.A*(1-Xmax));        
    % Mole Ratio
    moleratio = (LTS.Amod-LTS.Cmod) / (HTS.Amod-HTS.Bmod); 
else % HTS.steps == 2 && LTS.steps == 2
    % HTS Modified Coefficients
    HTS.Amod = 0.5*(HTS.C*(1-Xmax)+HTS.A*(1+Xmax));
    HTS.Bmod = HTS.B; % No Change
    HTS.Cmod = 0.5*(HTS.C*(1+Xmax)+HTS.A*(1-Xmax));     
    % LTS Modified Coefficients
    LTS.Amod = 0.5*(LTS.C*(1-Xmax)+LTS.A*(1+Xmax));
    LTS.Bmod = LTS.B; % No Change
    LTS.Cmod = 0.5*(LTS.C*(1+Xmax)+LTS.A*(1-Xmax));  
    % Mole Ratio
    moleratio = (LTS.Amod-LTS.Cmod) / (HTS.Amod-HTS.Cmod); 
end

if LTSchoice==1 %BaCl2
LTSaltMass=M.BaCl2; %BaCl2 SaltMass/vsENG
LTENGMass=LTSaltMass/Barium.MassRatio;
LTSlength = N.BaDiscs*Discx;
end
if LTSchoice==2 %CaCl2 both reactions
LTSaltMass=M.CaCl842; 
LTENGMass=LTSaltMass/Calcium.MassRatio;
LTSlength = N.Ca842Discs*Discx;
end
if LTSchoice==3   
end
if LTSchoice==4
LTSaltMass=M.MnCl2; %MnCl2 
LTENGMass=LTSaltMass/Manganese.MassRatio;
LTSlength = N.MnDiscs*Discx;
end

if HTSchoice==1 %BaCl2
HTSaltMass=M.BaCl2; %BaCl2 SaltMass/vsENG
HTENGMass=HTSaltMass/Barium.MassRatio;
HTSlength = N.BaDiscs*Discx;
end
if HTSchoice==2
HTSaltMass=M.CaCl842; 
HTENGMass=HTSaltMass/Calcium.MassRatio;
HTSlength = N.Ca842Discs*Discx;
end


if HTSchoice==4
HTSaltMass=M.MnCl2; %MnCl2 
HTENGMass=HTSaltMass/Manganese.MassRatio;
HTSlength = N.MnDiscs*Discx;
end

%LvH=((LTSalt/LTS.MW)*(LTS.Amod-LTS.Cmod))/((HTSalt/HTS.MW)*(HTS.Amod-HTS.Cmod));
LTS.n = LTSaltMass/LTS.MW; 
HTS.n = HTSaltMass/HTS.MW; %

molsNH3 = LTS.n*(LTS.Amod-LTS.Cmod);
molsHTS = HTS.n/(molsNH3/(HTS.Amod-HTS.Bmod));

%SSratio
LTS.SSV=((pi*(Tdi^2)/4)-(pi*((Tdi-TubeThickness*2)^2)/4))*LTSlength; %volume of tube per sample m3
HTS.SSV=((pi*(Tdi^2)/4)-(pi*((Tdi-TubeThickness*2)^2)/4))*HTSlength;
LTS.H2OV=pi*((Tdi-TubeThickness*2)^2)/4*LTSlength;
HTS.H2OV=pi*((Tdi-TubeThickness*2)^2)/4*HTSlength ;  %Volume of water/HTfluid
LTS.frac.SvENG=LTENGMass/LTSaltMass;        %Engmass / kg of LTsalt
HTS.frac.SvENG=HTENGMass/HTSaltMass;        %Engmass / kg of HTsalt
LTS.frac.SvS=(LTS.SSV*SS.Rho)/LTSaltMass;   %SteelTubemass / kg of LTsalt
HTS.frac.SvS=(HTS.SSV*SS.Rho)/HTSaltMass;   %SteelTubemass / kg of HTsalt
LTS.frac.SvW=(LTS.H2OV*H2O.Rho)/LTSaltMass; %MassofHTfluid in tube/ kg of LTsalt
HTS.frac.SvW=(HTS.H2OV*H2O.Rho)/HTSaltMass; %MassofHTfluid in tube/ kg of HTsalt

Al_SA = 258.73e-6;                          %Surface area of aluminium cross section m2
Al_SAD = 2700*Al_SA;                        %Mass/SA kg/m
Shell_SA = pi*(57.15e-3)^2 - pi*(54.15e-3)^2;%Cross sec SA shell m2
EndRingV = (pi*(54.15e-3)^2 - pi*(48.8e-3)^2)* 0.8e-3 ; %vol end ring
EndShellV= (pi*(57.15e-3)^2 - pi*(54.15e-3)^2) * 2 * 14.5e-3; %extra shell vol for flow of gas
EndPlateV= 3e-3 * (pi*(57.15e-3)^2 - ((pi*12.7e-3^2)/4)*7); %end of shell plate volume
Extratube= 21.5e-3*6*(12.7e-3^2/4-10.88e-3^2/4)...
    + 18.5e-3*(12.7e-3^2/4-10.88e-3^2/4);   % lengths of tub sticking out connected to manifold
ManifoldV= (74792.041+78681.748+2859.111)*10^-9; %manifold arrangement 
% volumes from fusion drawin mm^3
ManifoldConnectTV=(12.7e-3^2/4-10.88e-3^2/4)*18e-3;
EndVolumes =2*(EndRingV + EndShellV + EndPlateV + Extratube + ManifoldV +ManifoldConnectTV);
% ^ total end volume (made stainless)
%deemed constant whatever shell length (may change though)

% % % Calculations % % % 
T4 = t4 + 273.15; % [K] Conversion from degC to K
T2 = t2 + 273.15; % [K] Conversion from degC to K

fontsize = 12;
if HTS.steps == 1 && LTS.steps == 1 % Both single stage salts
    %   
    %   ln(p)  LTS           HTS
    %   ^             4a=2d
    %   |       (2a)/ /|           / /(3d)
    %   |          / / |          / /
    %   |         / /  |         / /
    %   |        / /   |        / / 
    %   |       / /    |       / /  
    %   |      / /     |      / /  
    %   |     / /      |     / / 
    %   |    / /       |    / /
    %   |   / /        |   / /
    %   |  / /         |  / / 
    %   | / /          | / /  
    %   |/ /(1d)   (4a)|/ /  
    %   |---------------------------> -1/T
    %
    % Mole swing
    LTS_swing = LTS.Amod-LTS.Bmod; % [mol NH3/mol LTS]
    HTS_swing = HTS.Amod-HTS.Bmod; % [mol NH3/mol HTS]
    % Pressures and Temperatures
    pL = exp(-(HTS.R1.delHdes/(R0*T4)/1000)+(HTS.R1.delSdes/R0/1000)); % [Pa] Low pressure
    pH = exp(-(LTS.R1.delHdes/(R0*T2)/1000)+(LTS.R1.delSdes/R0/1000)); % [Pa] High pressure
    T1 = (LTS.R1.delHads/1000/(LTS.R1.delSads/1000 - R0*log(pL))); % [K] HTS medium output temperature
    T3 = (HTS.R1.delHads/1000/(HTS.R1.delSads/1000 - R0*log(pH))); % [K] HTS desorption temperature
    
    % Reaction Heat
    Q1R = LTS.R1.delHreact/1000*molsNH3     ;      % [J LTS] LTS Desorb  LTS
    Q2R = LTS.R1.delHreact/1000*molsNH3     ;      % [J LTS] LTS Adsorb LTS
    Q3R = HTS.R1.delHreact/1000*molsNH3     ;      % [J LTS] HTS Ads per mole LTS
    Q4R = HTS.R1.delHreact/1000*molsNH3     ;      % [J LTS] HTS Des per mole LTS
    % Sensible Heat
    Q12 = (T2 - T1)*(LTS.Cp*LTSaltMass + NH3.Cps*LTS.Bmod*LTS.n + SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass);
    Q12shell = (T2 - T1)*(LTS.Cp*LTSaltMass + NH3.Cps*LTS.Bmod*LTS.n + SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass...
          + SHP*(Al_SAD*(LTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*LTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp)); % [J LTS] Per mole LTS heating (B loading)
    Q21 = (T2 - T1)*(LTS.Cp*LTSaltMass + NH3.Cps*LTS.Amod*LTS.n + SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass);
    Q21shell = (T2 - T1)*(LTS.Cp*LTSaltMass + NH3.Cps*LTS.Amod*LTS.n + SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass...
          + SHP*(Al_SAD*(LTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*LTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));%  [J LTS]Per mole LTS cooling (A loading)
    Q43 = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Amod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass);
    Q43shell = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Amod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass...
           + SHP*(Al_SAD*(HTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*HTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));% [J/mol LTS] Per mole HTS heating (A loading)
    Q34 = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Bmod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass);
    Q34shell = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Bmod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass...
           + SHP*(Al_SAD*(HTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*HTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));% [J/mol LTS] Per mole HTS cooling (B loading)
  
    ThermalMassShell= Al_SAD*(LTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*LTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp;
    ThermalMassTubeandFluid= SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass;
    VolumeShell= Al_SA*(LTSlength+2e-3) + Shell_SA*LTSlength + EndVolumes;
    VolumeTubeandFluid= LTS.frac.SvS*LTSaltMass + LTS.frac.SvW*LTSaltMass;
    
    % Gas Heat
    QgasH = (T3-T2)*(NH3.Cpg*NH3.MW*(molsNH3))/1000; % [J/mol LTS]
    QgasC = (T4-T1)*(NH3.Cpg*NH3.MW*(molsNH3))/1000; % [J/mol LTS]
    % Temp Conversion
    t3 = T3-273.15; 
    t1 = T1-273.15;
        % Plot - can be commmented out-------------------------------------
        figure(1) % Opens a new (blank) figure
        TK = [-20:20:250]'+273.15; % x temperature values
        x = 1./TK; % Sets the x data as -1/T (in K)
%         plim = [(pL/1e5)-1 (pH/1e5)+1];
        plim = [1 100];
        %HTS
        HTS.pads = @(x) exp((HTS.R1.delSads-HTS.R1.delHads*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        HTS.padata = HTS.pads(x);
        HTS.pdes = @(x) exp((HTS.R1.delSdes-HTS.R1.delHdes*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        HTS.pddata = HTS.pdes(x);
        %LTS
        LTS.pads = @(x) exp((LTS.R1.delSads-LTS.R1.delHads*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        LTS.padata = LTS.pads(x);
        LTS.pdes = @(x) exp((LTS.R1.delSdes-LTS.R1.delHdes*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        LTS.pddata = LTS.pdes(x);
        semilogy(-x, [LTS.padata, LTS.pddata, HTS.padata, HTS.pddata]*1e-5, 'LineWidth', 2) % p*1e-5 conversion to bar from Pa
%           semilogy(-x, [ LTS.pddata, HTS.pddata]*1e-5, 'LineWidth', 2)
        
        hold on
       
       
        % Pressure lines
        yline(pL/1e5, '--r', 'LineWidth', 2); yline(pH/1e5, '--r', 'LineWidth', 2)
        % Temperature lines
        xline(-1/T1, ':b', 'LineWidth', 2); xline(-1/T2, '--r', 'LineWidth', 2);
        xline(-1/T3, ':b', 'LineWidth', 2); %xline(-1/T4, ':b', 'LineWidth', 1);
        % Points
        plot(-1/T1, pL/1e5, '.k', 'MarkerSize',20); % Point 1
        plot(-1/T2, pH/1e5, '.k', 'MarkerSize',20); % Point 2
        plot(-1/T3, pH/1e5, '.k', 'MarkerSize',20); % Point 3
        plot(-1/T4, pL/1e5, '.k', 'MarkerSize',20); % Point 4
        %Formatting
        set(gca,... % Obtains current axes information
            'FontSize', fontsize,... % Font for graph
            'xtick', -x,... % Sets the x-axis ticks to -1/T (in K)
            'xlim', [-x(1) -x(end)],... % Sets the x-axis limits    
            'xticklabel', TK-273.15,... % Sets the x-tick labels to T in degrees C
            'ylim', plim)% Sets the y-axis limits (based on user input at the top)
        xlabel('Temperature / \circC', 'FontSize', fontsize+2) % Sets the x label. Note \circ is degree sym
        ylabel('Pressure / bar',  'FontSize', fontsize+2) % Sets the y label.
        grid on % Graphical grid on
        names = cell(4, 1);
        names{1} = strcat(LTS.Name, ' ads');
        names{2} = strcat(LTS.Name, ' des');
        names{3} = strcat(HTS.Name, ' ads');
        names{4} = strcat(HTS.Name, ' des');
        legend(names,... % Sets the legend to the names of salts in data struct.
        'Location', 'SouthEast',...% Legend location 
        'FontSize', fontsize); % Sets legend fontsize
    %----------------------------------------------------------------------
    
elseif HTS.steps == 1 && LTS.steps == 2
    %   
    %   ln(p)  LTS R1  LTS R2         HTS R1
    %   ^
    %   |         5  / /   (2d)/ /          / /(3a)
    %   |           / /       / /          / / 
    %   |          / /       / /          / /  
    %   |         / /       / /          / /
    %   |        / /                    / /  
    %   |       / /                    / / 
    %   |      / /                    / /  
    %   |     / /                    / / 
    %   |    / /                    / /  
    %   |   / /                    / /
    %   |  / /                    / /  
    %   | / / (1a)           (4d)/ /         
    %   |---------------------------------------> -1/T
    %
    % Mole swing    
    LTS_swing = LTS.Amod-LTS.Cmod;
    HTS_swing = HTS.Amod-HTS.Bmod;
    % Pressures and Temperatures
    pH = exp(-(LTS.R2.delHdes/(R0*T2)/1000)+(LTS.R2.delSdes/R0/1000)); % [Pa] Low pressure
    pL = exp(-(HTS.R1.delHdes/(R0*T4)/1000)+(HTS.R1.delSdes/R0/1000)); % [Pa] High pressure
    T1 = (LTS.R1.delHads/1000/(LTS.R1.delSads/1000 - R0*log(pL))); %adsorbed as a is the extreme point for which cooling/heating is too/from
    T3 = (HTS.R1.delHads/1000/(HTS.R1.delSads/1000 - R0*log(pH))); 
  
    pR12=pL+(pH-pL)*((LTS.C-LTS.B)/(LTS.C-LTS.A));
    
    T5d = (LTS.R1.delHdes/1000/(LTS.R1.delSdes/1000 - R0*log(pH))); % LTS desorption upper reaction 1 T
    T5a = (LTS.R1.delHads/1000/(LTS.R1.delSads/1000 - R0*log(pH))); % LTS adsorption upper reaction 1 T
    
    % Reaction Heat
    Q1R = LTS.R1.delHreact/1000*(LTS.Amod-LTS.Bmod)*LTS.n  + LTS.R2.delHreact/1000*(LTS.Bmod-LTS.Cmod)*LTS.n ;% LTS desorption heat both reactions
    Q2R = LTS.R1.delHreact/1000*(LTS.Amod-LTS.Bmod)*LTS.n + LTS.R2.delHreact/1000*(LTS.Bmod-LTS.Cmod)*LTS.n ;% LTS adsorption heat both reactions
    Q3R = (HTS.R1.delHreact/1000*(HTS_swing))*HTS.n ;% HTS desorption heat 
    Q4R = (HTS.R1.delHreact/1000*(HTS_swing))*HTS.n ;% HTS adsorption heat
   
    Q12 = (T2 - T1)*(LTS.Cp*LTSaltMass) + (T5d-T1)*NH3.Cps*LTS.Amod*LTS.n...
      + (T2-T5d)*(NH3.Cps*LTS.Bmod*LTS.n) + (T2 - T1)*(SS.Cp*LTS.frac.SvS*...
       LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass);
    Q12shell = (T2 - T1)*(LTS.Cp*LTSaltMass) + (T5d-T1)*NH3.Cps*LTS.Amod*LTS.n...
      + (T2-T5d)*(NH3.Cps*LTS.Bmod*LTS.n) + (T2 - T1)*(SS.Cp*LTS.frac.SvS*...
       LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass...
    + SHP*(Al_SAD*(LTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*LTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));% ) % [J LTS] Per mole LTS heating (B loading)
    
    Q21 = (T2 - T1)*(LTS.Cp*LTSaltMass + NH3.Cps*LTS.Amod*LTS.n + SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass);
    Q21shell = (T2 - T1)*(LTS.Cp*LTSaltMass + NH3.Cps*LTS.Amod*LTS.n + SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass + ENG.Cp*LTS.frac.SvENG*LTSaltMass...
        + SHP*(Al_SAD*(LTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*LTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));% ) %  [J LTS]Per mole LTS cooling (A loading)
    Q43 = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Amod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass);
    Q43shell = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Amod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass...
        + SHP*(Al_SAD*(HTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*HTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));%)%...         + Al_SAD*HTSlength*AlCp + Shell_SA*HTSlength*SS.Cp + EndVolumes*SS.Cp);% ) % [J/mol LTS] Per mole HTS heating (A loading)
    Q34 = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Bmod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass);
    Q34shell = (T3 - T4)*(HTS.Cp*HTSaltMass + NH3.Cps*HTS.Bmod*HTS.n + SS.Cp*HTS.frac.SvS*HTSaltMass + H2O.Cp*HTS.frac.SvW*HTSaltMass + ENG.Cp*HTS.frac.SvENG*HTSaltMass...
        + SHP*(Al_SAD*(HTSlength+2e-3)*AlCp + SS.Rho*Shell_SA*HTSlength*SS.Cp + SS.Rho*EndVolumes*SS.Cp));% ) % [J/mol LTS] Per mole HTS cooling (B loading)
     
    ThermalMassShell= Al_SAD*(LTSlength+2e-3)*AlCp + Shell_SA*LTSlength*SS.Cp + EndVolumes*SS.Cp;
    ThermalMassTubeandFluid= SS.Cp*LTS.frac.SvS*LTSaltMass + H2O.Cp*LTS.frac.SvW*LTSaltMass;
    VolumeShell= Al_SA*(LTSlength+2e-3) + Shell_SA*LTSlength + EndVolumes;
    VolumeTubeandFluid= LTS.frac.SvS*LTSaltMass + LTS.frac.SvW*LTSaltMass;
    
    % This needs checking in terms of sensible gas heating
    QgasH = ((T3-T5d)*(NH3.Cpg*NH3.MW*(LTS.Amod-LTS.Bmod))+(T3-T2)*(NH3.Cpg*NH3.MW*(LTS.Bmod-LTS.Cmod)))...
       *moleratio/1000; 
    QgasC = (T4-T1)*(NH3.Cpg*NH3.MW*(HTS_swing))/1000;
    % Temp Conversion
    t3 = T3-273.15; 
    t1 = T1-273.15;
    t5 = T5d-273.15; 

        % Plot - can be commmented out-------------------------------------

        figure(1) % Opens a new (blank) figure
        TK = [-20:20:220]'+273.15; % x temperature values
        x = 1./TK; % Sets the x data as -1/T (in K)

        plim = [0.1 25];
        %HTS
        HTS.pads = @(x) exp((HTS.R1.delSads-HTS.R1.delHads*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        HTS.padata = HTS.pads(x);
        HTS.pdes = @(x) exp((HTS.R1.delSdes-HTS.R1.delHdes*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        HTS.pddata = HTS.pdes(x);
        %LTS
        LTS.padsR1 = @(x) exp((LTS.R1.delSads-LTS.R1.delHads*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        LTS.padataR1 = LTS.padsR1(x);
        LTS.pdesR1 = @(x) exp((LTS.R1.delSdes-LTS.R1.delHdes*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        LTS.pddataR1 = LTS.pdesR1(x);
        LTS.padsR2 = @(x) exp((LTS.R2.delSads-LTS.R2.delHads*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        LTS.padataR2 = LTS.padsR2(x);
        LTS.pdesR2 = @(x) exp((LTS.R2.delSdes-LTS.R2.delHdes*x)/R0/1000); % p = exp^((dS-dH/T)/R0)
        LTS.pddataR2 = LTS.pdesR2(x);
        semilogy(-x,...
            [ LTS.padataR1,  LTS.pddataR1, LTS.padataR2, LTS.pddataR2, HTS.padata, HTS.pddata]*1e-5,...
            'LineWidth', 3) % p*1e-5 conversion to bar from Pa
        hold on
        % Pressure lines
        yline(pH/1e5, '--r', 'LineWidth', 2); yline(pL/1e5, '--r', 'LineWidth', 2);
        %yline(pR12/1e5, ':g', 'LineWidth', 2);%yline(pL/1e5, ':b', 'LineWidth', 1);
        % Temperature lines
        xline(-1/T1, ':g', 'LineWidth', 2); xline(-1/T2, '--r', 'LineWidth', 2);
        xline(-1/T3, ':g', 'LineWidth', 2); %xline(-1/T4, ':b', 'LineWidth', 1);
         xline(-1/T5d, ':g', 'LineWidth', 2);% xline(-1/T6d, ':g', 'LineWidth', 2);
        % Points
        plot(-1/T1, pL/1e5, '.k', 'MarkerSize',20); % Point 1
        plot(-1/T2, pH/1e5, '.k', 'MarkerSize',20); % Point 2
        plot(-1/T3, pH/1e5, '.k', 'MarkerSize',20); % Point 3
        plot(-1/T4, pL/1e5, '.k', 'MarkerSize',20); % Point 4
        plot(-1/T5d, pH/1e5, '.k', 'MarkerSize',20); % Point 5
       % plot(-1/T6d, pR12/1e5, '.k', 'MarkerSize',20); % Point 5

        set(gca,... % Obtains current axes information
            'FontSize', fontsize,... % Font for graph
            'xtick', -x,... % Sets the x-axis ticks to -1/T (in K)
            'xlim', [-x(1) -x(end)],... % Sets the x-axis limits    
            'xticklabel', TK-273.15,... % Sets the x-tick labels to T in degrees C
            'ylim', plim)% Sets the y-axis limits (based on user input at the top)
        xlabel('Temperature / \circC', 'FontSize', fontsize+2) % Sets the x label. Note \circ is degree sym
        ylabel('Pressure / bar',  'FontSize', fontsize+2) % Sets the y label.
        grid on % Graphical grid on
        names = cell(3, 1);
        names{1} = strcat(LTS.Name, ' R1 ads');
        names{2} = strcat(LTS.Name, ' R1 des');
        names{3} = strcat(LTS.Name, ' R2 ads');
        names{4} = strcat(LTS.Name, ' R2 des');
        names{5} = strcat(HTS.Name, ' R1 ads');
        names{6} = strcat(HTS.Name, ' R1 des');
        legend(names,... % Sets the legend to the names of salts in data struct.
        'Location', 'SouthEast',...% Legend location 
        'FontSize', fontsize); % Sets legend fontsize
    
    
end
% ENERGY BALANCE
pL
pH
LTSaltMass
HTSaltMass

% 2 reaction stage
TTin  = Q12 + QgasH + Q4R + Q2R 
TTout = Q3R - Q43                    
Tcold=T1-273
Thot=T3-273%   
COPTT = TTout/TTin
COPTTshell= (Q3R - Q43shell)/(Q12shell + QgasH + Q4R + Q2R)
 


    %   ln(p)  LTS           HTS
    %   ^             4a=2d
    %   |       (2a)/ /|           / /(3d)         
    %   |          / / |          / /
    %   |         / /  |         / /
    %   |        / /   |        / / 
    %   |       / /    |       / /  
    %   |      / /     |      / /  
    %   |     / /      |     / / 
    %   |    / /       |    / /
    %   |   / /        |   / /
    %   |  / /         |  / / 
    %   | / /          | / /  
    %   |/ /(1d)   (4a)|/ /  
    %   |---------------------------> -1/T
    %


