function [output1] = salt()
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
EQ = menu('Choose EQ ','ITC','LTJ')
i = 0;
%% Barium Chloride (BaCl2)
i = i + 1;
SALT(i).Name = 'BaCl_2';
SALT(i).MW = 208.23; % [g/mol]  MW BaCl2 137.33 + 2*35.453
SALT(i).rho = 3856; % [kg/m3] from Wiki (anhydrous) rho of unammoniated salt Wiki
SALT(i).Cp = 361.2; % [J/kg/K] https://webbook.nist.gov/cgi/cbook.cgi?ID=C10361372&Mask=2&Type=JANAFS&Table=on Specific heat of BaCl2 (Nist 75.22 J/kgK)
SALT(i).Reaction = '8 - 0';
% Reaction 1
    SALT(i).R1.Properties.Xmax = 8; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R1.Properties.Xmin = 0; % Max moles NH3 per mole salt, assumed equal in all nodes

    SALT(i).R1.Properties.delHads = 37360200; % [J/kmol] Altered with LTJ results SH
    SALT(i).R1.Properties.delHdes = 48924790; % [J/kmol] Altered with LTJ results SH

    SALT(i).R1.Properties.delSads = 229254.2; % [J/kmol/K] Altered with LTJ results SH
    SALT(i).R1.Properties.delSdes = 263993; % [J/kmol/K]Altered with LTJ results    SH
if EQ == 1    
    %ITC values to try with less hysteresis
    SALT(i).R1.Properties.delHads = 43182820; %38308050; % [J/kmol] Reaction enthalpy for BaCl ITC
    SALT(i).R1.Properties.delHdes = 38308050; % [J/kmol] Reaction enthalpy for BaCl ITC 
    SALT(i).R1.Properties.delSads = 246748; %232090; % [J/kmol/K] Reaction entropy change for BaCl ITC 
    SALT(i).R1.Properties.delSdes = 232090; % [J/kmol/K] Reaction entropy change BaCl ITC
end
    
    
    SALT(i).R1.Properties.delHreact = 40745440; % [J/kmol] Heat of reaction ITC SH
        
    SALT(i).R1.Properties.dHa = SALT(i).R1.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dHd = SALT(i).R1.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dSa = SALT(i).R1.Properties.delSads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dSd = SALT(i).R1.Properties.delSdes/SALT(i).MW; % [J/kg] Adjustment of units
    % Equation 1
    SALT(i).R1.EqnParameters.Eq1.ydes = 2; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Ades = 3; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.yads = 2;% Dynamic parameter adsorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Aads = 0.1; % Dynamic parameter adsorption Eq1
    % Equation 2
    SALT(i).R1.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eades = 25000; % Dynamic parameter adsorption Eq2
%% Calcium Chloride (CaCl2)
i = i + 1;
SALT(i).Name = 'CaCl_2';% 4-2';
SALT(i).MW = 110.984; % [g/mol] MW CaCl2 40.08 + 2*35.453
SALT(i).rho = 2150; % [kg/m3] from Wiki (anhydrous) Density of unammoniated salt Wiki
SALT(i).Cp = 656.8; % [J/kg/K] % Specific heat of CaCl2 (J/kgK) (Wiki 72.89 J/kgK) 
SALT(i).Reaction = '8 - 4, 4 - 2';
% Reaction 1 (8-4)
    SALT(i).R1.Properties.Xmax = 8; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R1.Properties.Xmin = 4; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R1.Properties.delHads = 32844620; % [J/kmol] Reaction enthalpy for CaCl2 4-8
    SALT(i).R1.Properties.delHdes = 36365790; % [J/kmol] Reaction enthalpy for CaCl2 8-4 from LTJ
    SALT(i).R1.Properties.delSads =208302; % [J/kmol/K] Reaction entropy change for CaCl2 4-8 % 
    SALT(i).R1.Properties.delSdes = 217432; % [J/kmol/K] Reaction entropy change for CaCl2 8-4
  if EQ == 1   
    %ITC results test
    SALT(i).R1.Properties.delHads = 42630740; % [J/kmol] Reaction enthalpy for CaCl2 4-8
    SALT(i).R1.Properties.delHdes = 41529910; % [J/kmol] Reaction enthalpy for CaCl2 8-4 from LTJ
    SALT(i).R1.Properties.delSads = 236862; % [J/kmol/K] Reaction entropy change for CaCl2 4-8 % 
    SALT(i).R1.Properties.delSdes = 233370; % [J/kmol/K] Reaction entropy change for CaCl2 8-4
  end
    
    
    
    SALT(i).R1.Properties.delHreact = 42080320; % [J/kmol] Heat of reaction CaCl2 8-4 ITC SH
    
    SALT(i).R1.Properties.dHa = SALT(i).R1.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dHd = SALT(i).R1.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dSa = SALT(i).R1.Properties.delSads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dSd = SALT(i).R1.Properties.delSdes/SALT(i).MW; % [J/kg] Adjustment of units
    % Equation 1
    SALT(i).R1.EqnParameters.Eq1.ydes = 2; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Ades = 3; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.yads = 2;% Dynamic parameter adsorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Aads = 2; % Dynamic parameter adsorption Eq1
    % Equation 2
    SALT(i).R1.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eades = 25000; % Dynamic parameter adsorption Eq2
    

% %  1 (4-2) maybe useful based on Goetz Spinner paper as HTsalt with
% % bacl2
%     SALT(i).R1.Properties.Xmax = 4; % Max moles NH3 per mole salt, assumed equal in all nodes
%     SALT(i).R1.Properties.Xmin = 2; % Max moles NH3 per mole salt, assumed equal in all nodes
%     SALT(i).R1.Properties.delHads = 31699720; %31699720; % [J/kmol] Reaction enthalpy for CaCl2 2-4
%     SALT(i).R1.Properties.delHdes = 41202320; % [J/kmol] Reaction enthalpy for CaCl2 4-2
%     SALT(i).R1.Properties.delSads = 202390; %202390; % [J/kmol/K] Reaction entropy change for CaCl2 2-4 % +5000 a guess from REC code added here 21/08/20 from LTJ2R
%     SALT(i).R1.Properties.delSdes = 224432; % [J/kmol/K]Reaction entropy change for CaCl2 4-2
%     
%     SALT(i).R1.Properties.delHreact = 39948770; % [J/kmol] Heat of reaction CaCl2 4-2 ITC SH
%   
%     SALT(i).R1.Properties.dHa = SALT(i).R1.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
%     SALT(i).R1.Properties.dHd = SALT(i).R1.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
%     SALT(i).R1.Properties.dSa = SALT(i).R1.Properties.delSads/SALT(i).MW; % [J/kg] Adjustment of units
%     SALT(i).R1.Properties.dSd = SALT(i).R1.Properties.delSdes/SALT(i).MW; % [J/kg] Adjustment of units
%     % Equation 1
%     SALT(i).R1.EqnParameters.Eq1.ydes = 1; % Dynamic parameter desorption Eq1
%     SALT(i).R1.EqnParameters.Eq1.Ades = 2; % Dynamic parameter desorption Eq1
%     SALT(i).R1.EqnParameters.Eq1.yads = 3;% Dynamic parameter adsorption Eq1
%     SALT(i).R1.EqnParameters.Eq1.Aads = 2; % Dynamic parameter adsorption Eq1
% %     Equation 2
%     SALT(i).R1.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
%     SALT(i).R1.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
%     SALT(i).R1.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
%     SALT(i).R1.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
%     SALT(i).R1.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
%     SALT(i).R1.EqnParameters.Eq2.Eades = 25000; % Dynamic parameter adsorption Eq2
%     
%     %ITC results test
%  if EQ == 1 
%     SALT(i).R1.Properties.delHads = 39709040; % [J/kmol] Reaction enthalpy for CaCl2 2-4
%     SALT(i).R1.Properties.delHdes = 41519930; % [J/kmol] Reaction enthalpy for CaCl2 4-2 from LTJ
%     SALT(i).R1.Properties.delSads = 224037; % [J/kmol/K] Reaction entropy change for CaCl2 4-2 % 
%     SALT(i).R1.Properties.delSdes = 228323; % [J/kmol/K] Reaction entropy change for CaCl2 2-4
% end
% %            
    
% Reaction 2 (4-2) 
    SALT(i).R2.Properties.Xmax = 4; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R2.Properties.Xmin = 2; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R2.Properties.delHads = 31699720 %31699720; % [J/kmol] Reaction enthalpy for CaCl2 2-4
    SALT(i).R2.Properties.delHdes = 41202320; % [J/kmol] Reaction enthalpy for CaCl2 4-2
    SALT(i).R2.Properties.delSads = 202390; %202390; % [J/kmol/K] Reaction entropy change for CaCl2 2-4 % +5000 a guess from REC code added here 21/08/20 from LTJ2R
    SALT(i).R2.Properties.delSdes = 224432; % [J/kmol/K]Reaction entropy change for CaCl2 4-2
    
    SALT(i).R2.Properties.delHreact = 39948770; % [J/kmol] Heat of reaction CaCl2 4-2 ITC SH
    
    SALT(i).R2.Properties.dHa = SALT(i).R2.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R2.Properties.dHd = SALT(i).R2.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R2.Properties.dSa = SALT(i).R2.Properties.delSads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R2.Properties.dSd = SALT(i).R2.Properties.delSdes/SALT(i).MW; % [J/kg] Adjustment of units
    % Equation 1
    SALT(i).R2.EqnParameters.Eq1.ydes = 1; % Dynamic parameter desorption Eq1
    SALT(i).R2.EqnParameters.Eq1.Ades = 2; % Dynamic parameter desorption Eq1
    SALT(i).R2.EqnParameters.Eq1.yads = 3;% Dynamic parameter adsorption Eq1
    SALT(i).R2.EqnParameters.Eq1.Aads = 2; % Dynamic parameter adsorption Eq1
%     Equation 2
    SALT(i).R2.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Eades = 25000; % Dynamic parameter adsorption Eq2
    
    %ITC results test
if EQ == 1 
    SALT(i).R2.Properties.delHads = 39709040; % [J/kmol] Reaction enthalpy for CaCl2 2-4
    SALT(i).R2.Properties.delHdes = 41519930; % [J/kmol] Reaction enthalpy for CaCl2 4-2 from LTJ
    SALT(i).R2.Properties.delSads = 224037; % [J/kmol/K] Reaction entropy change for CaCl2 4-2 % 
    SALT(i).R2.Properties.delSdes = 228323; % [J/kmol/K] Reaction entropy change for CaCl2 2-4
 end     
%             
%% Ammonium Chloride (NH4Cl)
i = i + 1;
SALT(i).Name = 'NH_4Cl';
SALT(i).MW = 53.491; % [g/mol]  ~14.0067 + 4*1.00784 +  35.453
SALT(i).rho = 1519; % [kg/m3] from https://en.wikipedia.org/wiki/Ammonium_chloride
SALT(i).Cp = 1624; % [J/kg/K] 86.88 j/molK / 53.493 g/mol * 1000 g/kg https://webbook.nist.gov/cgi/cbook.cgi?ID=C12125029&Type=JANAFS&Table=on#JANAFS
SALT(i).Reaction = '3 - 0';
% Reaction 1
    SALT(i).R1.Properties.Xmax = 3; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R1.Properties.Xmin = 0; % Max moles NH3 per mole salt, assumed equal in all nodes
%     % Olivera
    SALT(i).R1.Properties.delHads = 26693060.15; % [J/kmol] Oliviera
    SALT(i).R1.Properties.delHdes = 28976166.93; % [J/kmol] Oliviera
    SALT(i).R1.Properties.delSads = 198454; % [J/kmol/K] Oliviera
    SALT(i).R1.Properties.delSdes = 204199; % [J/kmol/K] Oliviera

    SALT(i).R1.Properties.dHa = SALT(i).R1.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dHd = SALT(i).R1.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dSa = SALT(i).R1.Properties.delSads/SALT(i).MW; % [J/kg/K] Adjustment of units
    SALT(i).R1.Properties.dSd = SALT(i).R1.Properties.delSdes/SALT(i).MW; % [J/kg/K] Adjustment of units
    % Equation 1
    SALT(i).R1.EqnParameters.Eq1.ydes = 2; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Ades = 3; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.yads = 0.2;% Dynamic parameter adsorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Aads = 0.1; % Dynamic parameter adsorption Eq1
    % Equation 2
    SALT(i).R1.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eades = 25000; % Dynamic parameter adsorption Eq2
    
    
    %dummy values from CaCl2 as a quick fix to ensure R2 functions occur.
%         Reaction 2 (4-2)
    SALT(i).R2.Properties.Xmax = 4; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R2.Properties.Xmin = 2; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R2.Properties.delHads = 31699720; % [J/kmol] Reaction enthalpy for CaCl2 2-4
    SALT(i).R2.Properties.delHdes = 41202320; % [J/kmol] Reaction enthalpy for CaCl2 4-2
    SALT(i).R2.Properties.delSads = 202390; % [J/kmol/K] Reaction entropy change for CaCl2 2-4 % +5000 a guess from REC code added here 21/08/20 from LTJ2R
    SALT(i).R2.Properties.delSdes = 224432; % [J/kmol/K]Reaction entropy change for CaCl2 4-2
    
    SALT(i).R2.Properties.delHreact = 39948770; % [J/kmol] Heat of reaction CaCl2 4-2 ITC SH
    
    SALT(i).R2.Properties.dHa = SALT(i).R2.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R2.Properties.dHd = SALT(i).R2.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R2.Properties.dSa = SALT(i).R2.Properties.delSads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R2.Properties.dSd = SALT(i).R2.Properties.delSdes/SALT(i).MW; % [J/kg] Adjustment of units
    % Equation 1
    SALT(i).R2.EqnParameters.Eq1.ydes = 1; % Dynamic parameter desorption Eq1
    SALT(i).R2.EqnParameters.Eq1.Ades = 2; % Dynamic parameter desorption Eq1
    SALT(i).R2.EqnParameters.Eq1.yads = 3;% Dynamic parameter adsorption Eq1
    SALT(i).R2.EqnParameters.Eq1.Aads = 2; % Dynamic parameter adsorption Eq1
%     Equation 2
    SALT(i).R2.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
    SALT(i).R2.EqnParameters.Eq2.Eades = 25000; % Dynam
%% Manganese Chloride (MnCl2)
i = i + 1;
SALT(i).Name = 'MnCl_2';
SALT(i).MW = 125.844; % [g/mol]  54.938 +  2*35.453
SALT(i).rho = 2977; % [kg/m3] from https://en.wikipedia.org/wiki/Manganese(II)_chloride
SALT(i).Cp = 595.98; % [J/kg/K] 75 j/molK / 125.844 g/mol * 1000 g/kg https://webbook.nist.gov/cgi/cbook.cgi?ID=C7786303&Type=JANAFS&Plot=on#JANAFS
SALT(i).Reaction = '6 - 2';
% Reaction 1
    SALT(i).R1.Properties.Xmax = 6; % Max moles NH3 per mole salt, assumed equal in all nodes
    SALT(i).R1.Properties.Xmin = 2; % Max moles NH3 per mole salt, assumed equal in all nodes
     SALT(i).R1.Properties.delHads = 36611107; % [J/kmol] Sam
     SALT(i).R1.Properties.delHdes = 58196253; % [J/kmol] Sam
     SALT(i).R1.Properties.delSads = 202865; % [J/kmol/K] Sam
     SALT(i).R1.Properties.delSdes = 253641; % [J/kmol/K] Sam

    % ITC results 
    if EQ == 1 
     SALT(i).R1.Properties.delHads = 40733400; % [J/kmol] Sam
     SALT(i).R1.Properties.delHdes = 46124477; % [J/kmol] Sam
     SALT(i).R1.Properties.delSads = 212484; % [J/kmol/K] Sam
     SALT(i).R1.Properties.delSdes = 224706; % [J/kmol/K] Sam
    end



    SALT(i).R1.Properties.delHreact = 43428929.4; % [J/kmol] Heat of reaction 

    SALT(i).R1.Properties.dHa = SALT(i).R1.Properties.delHads/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dHd = SALT(i).R1.Properties.delHdes/SALT(i).MW; % [J/kg] Adjustment of units
    SALT(i).R1.Properties.dSa = SALT(i).R1.Properties.delSads/SALT(i).MW; % [J/kg/K] Adjustment of units
    SALT(i).R1.Properties.dSd = SALT(i).R1.Properties.delSdes/SALT(i).MW; % [J/kg/K] Adjustment of units
    % Equation 1
    SALT(i).R1.EqnParameters.Eq1.ydes = 3; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Ades = 3; % Dynamic parameter desorption Eq1
    SALT(i).R1.EqnParameters.Eq1.yads = 2;% Dynamic parameter adsorption Eq1
    SALT(i).R1.EqnParameters.Eq1.Aads = 2; % Dynamic parameter adsorption Eq1
    % Equation 2
    SALT(i).R1.EqnParameters.Eq2.yadsln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.ydesln = 1; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Clads = 500;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Cldes = 100; % Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eaads = 25000;% Dynamic parameter adsorption Eq2
    SALT(i).R1.EqnParameters.Eq2.Eades = 25000; % Dynamic parameter adsorption Eq2

     
%% OUTPUT     
output1 = SALT;
end